<template>
    <div id="app">
        <startScreen
            @WhatIWantEvent="funcionalidadButtonWhatIwant"
            @randomEvent="funcionalidadButtonRandom"
            :stateStartScreen="showStartScreen"
        />
        <CustomizedSearch
            @categoryEvent="funcionalidadButtonCategory"
            @keyWordEvent="funcionalidadButtonKeyWord"
            @goBackEvent="functionReturnScreen"
            @backHomeEvent="functionOnLoad"
            :stateCustomizedSearch="showCustomizedSearch"
            :categoriesToChooseFrom="categories"
        />
        <ShowScreenRecipeList
            @showRecipeEnFinalScreenEvent="funcionalidadShowDetails"
            @goBackEvent="functionReturnScreen"
            @backHomeEvent="functionOnLoad"
            :stateRecipeList="showShowScreenRecipeList"
            :recipesList="arraytestCategory"
        />
        <FinalScreen @randomEvent="funcionalidadButtonRandom"
        @backHomeEvent="functionOnLoad"
       @goBackEvent="functionReturnScreen"
        
         :stateFinalScreen="showFinalScreen" 
         :datax="arraytest" 
         />
    </div>
</template>

<script>
import StartScreen from './components/StartScreen.vue'
import CustomizedSearch from './components/CustomizedSearch.vue'
import ShowScreenRecipeList from './components/ShowScreenRecipeList.vue'
import FinalScreen from './components/FinalScreen.vue'
export default {
    name: 'app',
    data() {
        return {
            categories: [
                'Beef',
                'Breakfast',
                'Chicken',
                'Dessert',
                'Goat',
                'Lamb',
                'Miscellanius',
                'Pasta',
                'Pork',
                'Seafood',
                'Side',
                'Starter',
                'Vegan',
                'Vegetarian',
            ],
            typeOfCall: '',
            nextScreen: '',
            showStartScreen: false,
            showCustomizedSearch: false,
            showShowScreenRecipeList: false,
            showFinalScreen: false,
            resultsAPI: null,
            arraytest: [],
            arraytestCategory: [],
        }
    },
    components: {
        StartScreen,
        CustomizedSearch,
        ShowScreenRecipeList,
        FinalScreen,
    },
    el: "#app",
  mounted: function() {
    this.functionOnLoad(); //method1 will execute at pageload
  },
    methods: {
        functionOnLoad() {
      this.hideAllScreen();
      this.showStartScreen = true;
    },
    
        generateUrl(typeOfCall, value) {
            let urlBase = 'https://www.themealdb.com/api/json/v1/1/'
            const ipProxy = 'http://192.168.1.54:3000/'
            let urlFinal
            switch (typeOfCall) {
                case 'id':
                    urlFinal = urlBase.concat('lookup.php?i=')
                    urlFinal.concat(value)
                    console.log('url con id', urlFinal)
                    break
                case 'ingredient':
                    urlFinal = urlBase.concat('filter.php?i=')
                    urlFinal.concat(value)
                    console.log('url con ingredient', urlFinal)
                    break
                case 'category':
                    urlFinal = urlBase.concat('filter.php?c=')
                    urlFinal = urlFinal.concat(value)
                    break
                default:
                    urlFinal = ipProxy.concat(urlBase.concat('random.php'))
                    break
            }
            return urlFinal
        },

        //lamada a la API
        async callApi(url) {
            let result
            this.resultsAPI = await fetch(url)
            result = await this.resultsAPI.json()
            return result
        },

        formatYoutubeURL(youtubeUrl) {
            let position = youtubeUrl.indexOf('=')
            let result = youtubeUrl.substring(position + 1)

            result = 'https://www.youtube.com/embed/' + result
            return result
        },

        mapJson(json) {
            let newJson = json.meals.map(recipeFields => {
                let formatedYoutubeUrl = this.formatYoutubeURL(
                    recipeFields.strYoutube
                )
                console.log('URL DE YOUTUBE FORMATEADA', formatedYoutubeUrl)
                return {
                    strMeal: 'TITULO: ' + recipeFields.strMeal,
                    strMealThumb: recipeFields.strMealThumb,
                    idMeal: recipeFields.idMeal,
                    strDrinkAlternate: recipeFields.strDrinkAlternate,
                    strCategory: 'Category: ' + recipeFields.strCategory,
                    strInstructions:
                        'Instructions: ' + recipeFields.strInstructions,
                    strYoutube: formatedYoutubeUrl,
                    strIngredient1: recipeFields.strIngredient1,
                    strIngredient2: recipeFields.strIngredient2,
                    strIngredient3: recipeFields.strIngredient3,
                    strIngredient4: recipeFields.strIngredient4,
                    strIngredient5: recipeFields.strIngredient5,
                    strIngredient6: recipeFields.strIngredient6,
                    strIngredient7: recipeFields.strIngredient7,
                    strIngredient8: recipeFields.strIngredient8,
                    strIngredient9: recipeFields.strIngredient9,
                    strIngredient10: recipeFields.strIngredient10,
                    strIngredient11: recipeFields.strIngredient11,
                    strIngredient12: recipeFields.strIngredient12,
                    strIngredient13: recipeFields.strIngredient13,
                    strIngredient14: recipeFields.strIngredient14,
                    strIngredient15: recipeFields.strIngredient15,
                    strIngredient16: recipeFields.strIngredient16,
                    strIngredient17: recipeFields.strIngredient17,
                    strIngredient18: recipeFields.strIngredient18,
                    strIngredient19: recipeFields.strIngredient19,
                    strIngredient20: recipeFields.strIngredient20,
                    strMeasure1: recipeFields.strMeasure1,
                    strMeasure2: recipeFields.strMeasure2,
                    strMeasure3: recipeFields.strMeasure3,
                    strMeasure4: recipeFields.strMeasure4,
                    strMeasure5: recipeFields.strMeasure5,
                    strMeasure6: recipeFields.strMeasure6,
                    strMeasure7: recipeFields.strMeasure7,
                    strMeasure8: recipeFields.strMeasure8,
                    strMeasure9: recipeFields.strMeasure9,
                    strMeasure10: recipeFields.strMeasure10,
                    strMeasure11: recipeFields.strMeasure11,
                    strMeasure12: recipeFields.strMeasure12,
                    strMeasure13: recipeFields.strMeasure13,
                    strMeasure14: recipeFields.strMeasure14,
                    strMeasure15: recipeFields.strMeasure15,
                    strMeasure16: recipeFields.strMeasure16,
                    strMeasure17: recipeFields.strMeasure17,
                    strMeasure18: recipeFields.strMeasure18,
                    strMeasure19: recipeFields.strMeasure19,
                    strMeasure20: recipeFields.strMeasure20,
                    strSource: recipeFields.strSource,
                }
            })
            return newJson
        },

        hideAllScreen() {
            this.showStartScreen = false
            this.showCustomizedSearch = false
            this.showShowScreenRecipeList = false
            this.showFinalScreen = false
        },

        emitShowRecipes() {},
        functionReturnScreen() {
            switch (this.nextScreen) {
                case 'customized':
                    this.hideAllScreen()
                    this.showStartScreen = true
                    this.nextScreen=""
                    break
                case 'lista':
                    this.hideAllScreen()
                    this.showCustomizedSearch = true
                    this.nextScreen="customized"
                    break
                case 'final':
                    this.hideAllScreen()
                    this.showShowScreenRecipeList = true
                    this.nextScreen="lista"
                    break;
                default:
                    this.hideAllScreen()
                    this.showStartScreen = true
                    break
            }
        },

        functionShowScreen() {
            switch (this.nextScreen) {
                case 'customized':
                    this.hideAllScreen()
                    this.showCustomizedSearch = true
                    break
                case 'lista':
                    this.hideAllScreen()
                    this.showShowScreenRecipeList = true
                    break
                case 'final':
                    this.hideAllScreen()
                    this.showFinalScreen = true
                    break
                default:
                    this.showStartScreen = true
                    break
            }
        },

        async funcionalidadButtonRandom() {
            this.nextScreen = 'final'
            this.functionShowScreen()
            let urlAPI = this.generateUrl('random', null)
            let myJson = await this.callApi(urlAPI)
            this.arraytest = this.mapJson(myJson)
        },

        funcionalidadButtonWhatIwant() {
            this.nextScreen = 'customized'
            this.functionShowScreen()
        },

        async funcionalidadButtonCategory(categoryValue) {
            this.nextScreen = 'lista'
            this.functionShowScreen()
            let urlAPI = this.generateUrl('category', categoryValue)
            console.log('urlAPI', urlAPI)
            let myJson = await this.callApi(urlAPI)
            console.log('myJson', myJson)
            this.arraytestCategory = myJson
            console.log('this.arraytest', this.arraytestCategory.meals)
        },

        async funcionalidadButtonKeyWord(keywordValue) {
            this.nextScreen = 'lista'
            this.functionShowScreen()
            let urlAPI = this.generateUrl('category', keywordValue)
            console.log('urlAPI', urlAPI)
            let myJson = await this.callApi(urlAPI)
            console.log('myJson', myJson)
            this.arraytestCategory = myJson
            console.log('this.arraytest', this.arraytestCategory.meals)
        },

       async funcionalidadShowDetails(idValue) {
            this.nextScreen = 'final'
            this.functionShowScreen()
            let urlAPI = this.generateUrl('random', idValue)
            let myJson = await this.callApi(urlAPI)
            this.arraytest = this.mapJson(myJson)
        },
    },
}
</script>

<style>
#app {
    font-family: 'Avenir', Helvetica, Arial, sans-serif;
    -webkit-font-smoothing: antialiased;
    -moz-osx-font-smoothing: grayscale;
    text-align: center;
    color: #2c3e50;
    margin-top: 60px;
}
</style>
